#!/usr/bin/env python

from mod_python import apache
import time
import string
import sys

from msb_web import *

client_side_xslt = True

msb = apache.import_module("msb.msb_conf", path=[logic_root], autoreload = 1, log = 1)
fss_xml = apache.import_module("fss_xml", path=[document_root], autoreload = 1, log = 1)

def user_agent(req):
	req.add_common_vars()
	if req.subprocess_env.has_key("HTTP_USER_AGENT"):
		return req.subprocess_env["HTTP_USER_AGENT"]
	return "unknown"

def is_ie(browser):
	if browser.find("MSIE") > 0:
		return True
	if browser.find("Gecko") > 0:
		return False
	if browser.find("Konqueror") > 0:
		return False
	if browser.find("Windows") > 0:
		return True
	return False

def handle_module(req, xml, module):
	sub = apache.import_module(module, path=[document_root], autoreload = 1, log = 1)
	return sub.handler(req,xml, msb.conf)

def handler(req): 
	xml = fss_xml.FSSXML() 
	xml.data("<?xml-stylesheet type='text/xsl' href='msb.xslt'?>\n");
	xml.push("msb:response", "xmlns='http://www.w3.org/1999/xhtml' xmlns:msb='http://asp.mexmat.net/xmlns/msb'");
	timer = time.time()

	module = req.filename
	if module[0:len(document_root)] == document_root:
		module = module[len(document_root):]
		if len(module) > 3 and module[len(module)-3:] == ".py":
			module = module[0:len(module)-3]

	counter = 0
	try :
		xml.push("msb:body")
		modules = ["index", "info", "admin", "add_ip"]
		if modules.count(module) == 0:
			module = "index"
			xml.data("<msb:error>Unknown module: %s </msb:error>\n" % module);
		handle_module(req, xml, module)
		#counter = add_counter(module)
		xml.pop("msb:body")
	except RuntimeError, e:
		xml.pop("msb:body")
		xml.data("<msb:error>"+ e.__str__() +"</msb:error>\n");
	except MSBRedirect, e:
		req.err_headers_out.add('Location', e.url)
		req.status = apache.HTTP_MOVED_TEMPORARILY
		return apache.OK
	"""
	except:
		xml.pop("msb:body")
		xml.data("<msb:error>Internal error</msb:error>\n");
		"""

	xml.push("msb:meta")
	xml.data("<msb:line>"+time.ctime()+"</msb:line>\n");
	xml.data("<msb:timer type='web'>%.3f</msb:timer>" % (timer - req.request_time))
	xml.data("<msb:timer type='query'>%.3f</msb:timer>" % (time.time() - timer))
	if not client_side_xslt:
		xml.data("<msb:timer type='xslt'><xslt-timing/></msb:timer>")
	xml.data("<msb:line>counter: %d</msb:line>\n" % counter)
	#xml.data("<msb:line>agent: %s</msb:line>\n" % user_agent(req))
	xml.pop()
	timer = time.time()
	if client_side_xslt:
		req.content_type="text/xml; charset=UTF-8";
		req.write(xml.xml());
		return apache.OK
	
	from fss_xslt import FSSXSLT

	msie = is_ie(user_agent(req))
		
	xslt = FSSXSLT(document_root + "/msb.xslt")
	tmp = xslt.xslt(xml)

	if msie:
		req.content_type="text/html; charset=UTF-8";
		ind = tmp.find("<html")
		tmp = tmp[ind:]
		#tmp = tmp.replace('xmlns="http://www.w3.org/1999/xhtml"', "")
	else:
		req.content_type="application/xhtml+xml; charset=UTF-8";
	tmp = string.replace(tmp, "<xslt-timing/>", "%.3f" % (time.time() - timer))


	req.write(string.replace(tmp, 'xmlns:fss="http://asp.mexmat.net/xmlns/fss"', ""))
	return apache.OK 
